//#############################################################################   
//
//	Headerdatei usb4all.h
//
//#############################################################################

//#define DEBUG

//#############################################################################

#include <stdio.h>
#include <stdlib.h>
#include <usb.h>
#include <time.h>
#include <errno.h>
#include <string.h>

//#############################################################################

#define VENDOR			0x004d8	/* USB Device Hersteller */
#define PRODUCT			0x0ff0b /* USB Device Produkt    */

#define MODE_NORMAL             0x01    /* programmer in normal mode */
#define MODE_BOOT               0x02    /* programmer in boot loader mode */

#define MODE_INT                0x04    /* usb interface : interrup mode */
#define MODE_BULK               0x08    /* usb interface : bulk mode */

#define TIMEOUT_WRITE           100
#define TIMEOUT_READ            1000

#define USB_BLOCKSIZE           64

#define CMD_RESET               0xFF    /* reset controller PIC */
#define BOOT_RESET              0xFF    /* reset controller PIC */

//#############################################################################   
//
//	Datenstrukturen
//
//#############################################################################

struct usb4all_t {
	usb_dev_handle *dev;
	int interface;
	int ep_in, ep_out;
	int usbmode;
	int mode;
	char usb_name[64];
};

//#############################################################################
//
//	Prototypen
//
//#############################################################################

int usb4all_initialize(struct usb4all_t *usb4con);
int usb4all_connect(struct usb4all_t *usb4con);
int usb4all_finalize(struct usb4all_t *usb4con);
int usb4all_data_io(struct usb4all_t *usb4con, unsigned char *data_in, int data_in_cnt, unsigned char *data_out, int data_out_cnt);

//#############################################################################
